


{

NT Messenger for Linux
by Antti Kirjavainen

Sends messages simply using the smbclient -M-switch and echo.

You can do whatever you want with this code

}



unit Main;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, Libc;

type
  TfrmMain = class(TForm)
    cboAddress: TComboBox;
    txtMessage: TMemo;
    cmdSend: TButton;
    lblAddress: TLabel;
    lblMessage: TLabel;
    procedure cmdSendClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
        frmMain: TfrmMain;
        sConfigFile: String;

implementation

{$R *.xfm}

procedure TfrmMain.cmdSendClick(Sender: TObject);
var
        sCommand: String;
        Success: Integer;

begin
if (Length(txtMessage.Text) <= 0) then exit;
if (Length(cboAddress.Text) <= 0) then exit;

sCommand := 'echo "' + txtMessage.Text + '"|smbclient -M "' + cboAddress.Text + '"';
Success := Libc.system(PChar(sCommand));

if (Success < 0) then begin
                      MessageDlg('Sending failed. Make sure smbclient is in your path, or make a symbolic link to it.', mtError, [mbOK], 0);
                      end;

if (Success > 0) then begin
                      MessageDlg('Sending failed. Make sure the network is working and that you entered the correct address.', mtError, [mbOK], 0);
                      end;

if (Success = 0) then begin
                      if (cboAddress.Items.IndexOf(cboAddress.Text) < 0) then cboAddress.Items.Add(cboAddress.Text);  
                      MessageDlg('Message sent!', mtInformation, [mbOK], 0);
                      txtMessage.Clear();
                      end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
cboAddress.Clear();
sConfigFile := IncludeTrailingBackSlash(getenv('HOME')) + '.ntmes';

try
        if (FileExists(sConfigFile)) then cboAddress.Items.LoadFromFile(sConfigFile);
except
        cboAddress.Clear();
end;

end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
try
        if (cboAddress.Items.Count > 0) then cboAddress.Items.SaveToFile(sConfigFile);
except
        Application.Terminate();
end;
end;

end.
